//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Glyph prbg}bv̍쐬@
//  TImageListgp@
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  2017N1227 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://homepage2.nifty.com/Mr_XRAY/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ImgList;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    ImageList1: TImageList;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure SetGlyphFromTImageList(AImgListUp, AImgListDisable, AImgListClick,
      AImgListDown: TImageList; AButton: TObject; AImgIndex: Integer);
  public
    { Public 錾 }
  end;

  procedure SetBitmapAlpha(ABitmap: TBitMap);

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//  TImageListɊi[rbg}bvGlyphp̃rbg}bvĎgp@
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  CheckBox1.Checked := True;

  //wiF͌̃rbg}bvɂ͂ȂFɂ
  ImageList1.BkColor := clBlue;
  ImageList2.BkColor := clBlue;

  SetGlyphFromTImageList(ImageList1, ImageList2, nil, nil, SpeedButton1, 0);
  SetGlyphFromTImageList(ImageList1, ImageList2, nil, nil, SpeedButton2, 1);
end;

//=============================================================================
//  TSpeedButtonEnabledvpeB̐؂芷
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  SpeedButton1.Enabled := CheckBox1.Checked;
  SpeedButton2.Enabled := CheckBox1.Checked;
end;

//-----------------------------------------------------------------------------
//  TImageListɊi[Ă摜Glyphp̃rbg}bv쐬ăZbg
//
//  AImgListUp      : ʏ\摜i[TImageList
//  AImgListDisable : DisableȏԂ\摜i[TImageList
//  AImgListClick   : }EX̍{^ɕ\摜i[TImageList
//  AImgListDown    : DownvpeBTrue̎ɕ\摜i[TImageList
//  AButtton        : TSpeedButton܂TBitBtn
//  AImgIndex       : TimageList̉Ԗڂ̉摜gp邩̎w(0x[X)
//-----------------------------------------------------------------------------
procedure TForm1.SetGlyphFromTImageList(AImgListUp, AImgListDisable, AImgListClick,
  AImgListDown: TImageList; AButton: TObject; AImgIndex: Integer);

  procedure CopyTImgListBmpToGlyphCanvas(AImgList : TImageList; AGlyph: TBitmap;
    ANo: Integer);
  var
    LBitmap : TBitmap;
    LRect   : TRect;
  begin
    if AImgList = nil then exit;

    LBitmap := TBitmap.Create;
    try
      // GetBitmap  sNZȂ (TBitmap ƂĎ擾ꍇ)
      //  TBitmap Sɓȃrbg}bvɂĂ
      if AImgList.ColorDepth = cd32Bit then begin
        LBitmap.AlphaFormat := afDefined;
        LBitmap.SetSize(AImgList.Width, AImgList.Height);
        SetBitmapAlpha(LBitmap);
      end;

      if AImgList.GetBitmap(AImgIndex, LBitmap) then begin
        //Glyphprbg}bvCanvasɃrbg}bvƂĎ擾摜`悷
        LRect := Rect(LBitmap.Width * ANo, 0, LBitmap.Width * (ANo + 1), LBitmap.Height);
        AGlyph.Canvas.CopyRect(LRect,
                               LBitmap.Canvas,
                               Rect(0, 0, LBitmap.Width, LBitmap.Height));
      end;
    finally
      FreeAndNil(LBitmap);
    end;
  end;

var
  LGlphBmp  : TBitmap;
  LImgCount : Integer;
begin
  if AImgListUp = nil then exit;

  LGlphBmp := TBitmap.Create;
  try
    //Glyphprbg}bṽTCYݒ
    LImgCount := 1;
    if AImgListDisable <> nil then LImgCount := 2;
    if AImgListClick <> nil   then LImgCount := 3;
    if AImgListDown <> nil    then LImgCount := 4;
    LGlphBmp.SetSize(AImgListUp.Width * LImgCount, AImgListUp.Height);
    LGlphBmp.Canvas.FillRect(LGlphBmp.Canvas.ClipRect);

    //TImageList̉摜rbg}bvƂĎ擾āCGlyphCanvasɒǉĂ
    CopyTImgListBmpToGlyphCanvas(AImgListUp,      LGlphBmp, 0);
    CopyTImgListBmpToGlyphCanvas(AImgListDisable, LGlphBmp, 1);
    CopyTImgListBmpToGlyphCanvas(AImgListClick,   LGlphBmp, 2);
    CopyTImgListBmpToGlyphCanvas(AImgListDown,    LGlphBmp, 3);

    //GlyphvpeBݒ
    if AButton is TSpeedButton then begin
     TSpeedButton(AButton).Glyph :=  LGlphBmp;
    end;
    if AButton is TBitBtn then begin
     TBitBtn(AButton).Glyph :=  LGlphBmp;
    end;
  finally
    FreeAndNil(LGlphBmp);
  end;
end;

//----------------------------------------------------------------------------
//  ȃrbg}bv摜̍쐬
//  At@`l̃rbg}bṽsNZl̃NA
//  Red,Gree, Blue, Alphi lS0 ɂrbg}bvɂ
//----------------------------------------------------------------------------
procedure SetBitmapAlpha(ABitmap: TBitMap);
type
  TRGBQArray = array [0..High(Integer) div 4 - 1] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LPosY      : Integer;
  LPosX      : Integer;
  LScanArray : PRGBQArray;
begin
  ABitmap.Canvas.Lock;
  ABitmap.PixelFormat := pf32bit;

  for LPosY := 0 to ABitmap.Height - 1 do begin
    LScanArray := ABitmap.ScanLine[LPosY];
    for LPosX  := 0 to ABitmap.Width - 1 do begin
      LScanArray[LPosX].rgbRed      := 0;
      LScanArray[LPosX].rgbGreen    := 0;
      LScanArray[LPosX].rgbBlue     := 0;
      LScanArray[LPosX].rgbReserved := 0;
    end;
  end;

  ABitmap.Canvas.Unlock;
end;

end.
